//------------------------------------------------------------------------
// Copyright 2002, Avocent Corporation
//------------------------------------------------------------------------
// FILE        :  avoprint.c
// DESCRIPTION :  
//
//------------------------------------------------------------------------
// AUTHOR      :  E. Seabra
// DATE        :  March 2006
//
//------------------------------------------------------------------------
// HISTORY
//
// DATE           PROGRAMMER              MODIFICATIONS
//
//------------------------------------------------------------------------

#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <unistd.h>
#include <fcntl.h>
#include <string.h>

#include "avoprint.h"

static unsigned long gbl_avoprint_level = 0;

static int avoprint_fd = -1;

void avoPrintfSetLevel(unsigned long level)
{
	gbl_avoprint_level = level;
}

void avoPrintf(unsigned long level, const char *fmt, ...)
{
	char buf[1024];
	va_list ap;

	if ((level & gbl_avoprint_level) != level && !(level & AVODBG_ALWAYS)) {
		return;
	}

	if (avoprint_fd < 0) {
		if ((avoprint_fd = open("/dev/console", O_WRONLY, 0)) < 0) {
			return;
		}
	}

	va_start(ap, fmt);
	vsnprintf(buf, sizeof(buf), fmt, ap);
	write(avoprint_fd, buf, strlen(buf));
	va_end(ap);
}
