#include <sys/socket.h>
#include <netinet/in.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <signal.h>

#include "api_adsap2.h"

int main(int argc, char *argv[])
{
	UnixAdsap2_msg *msg;
	int fd;

	if ((fd = unixAdsap2_connect()) < 0) {
		printf("unixAdsap2_connect failed\n");
		return(-1);
	}

	if ((msg = unixAdsap2_new_req()) == NULL) {
		printf("unixAdsap2_new_req failed\n");
		return(-1);
	}

	msg->req.port_num = 10;

	if (inixAdsap2_put_field(5, UnixAdsap2FieldIdUsername, "edson")) {
		printf("unixAdsap2_put_field-1 failed\n");
		return(-1);
	}
	if (inixAdsap2_put_field(6, UnixAdsap2FieldIdPassword, "seabra")) {
		printf("unixAdsap2_put_field-2 failed\n");
		return(-1);
	}
	if (inixAdsap2_put_field(48, UnixAdsap2FieldIdBlobKey, "BlobBlobBlobBlobBlobBlobBlobBlobBlobBlobBlobBlob")) {
		printf("unixAdsap2_put_field-3 failed\n");
		return(-1);
	}

	if (unixAdsap2_putmsg(fd, msg)) {
		printf("unixAdsap2_putmsg failed\n");
		return(-1);
	}

	unixAdsap2_drop_req();
	
	if ((msg = unixAdsap2_getmsg(fd)) == NULL) {
		printf("unixAdsap2_getmsg failed\n");
		return(-1);
	}

	printf("rep_msg->size      : %d\n", msg->rep.size);
	printf("rep_msg->rtype     : %d\n", msg->rep.rtype);

	if (msg->rep.rtype == 1) {
		printf("rep_msg->rcode     : %d\n", msg->rep.rcode);
		printf("rep_msg->port_num  : %d\n", msg->rep.port_num);
		printf("rep_msg->privilege : %d\n", msg->rep.privilege);
		printf("rep_msg->preempt   : %d\n", msg->rep.preempt);
	}

	free(msg);

	return(0);
}

