/*
 *  Module:  aidp-ts.h (Avocent Install and Discovery Protocol for TS family)
 *
 *  Author:  Marcelo Peccin <marcelo.peccin@avocent.com>
 *
 *  Copyright:  (c) 2006 Avocent Corporation
 *
 *  Date:  May 10, 2006
 *
 *  Comments:  Avocent Install and Discovery Protocol product-specific
 *             definitions and functions interface.
 *             See also aidp-ts.c and aidpaux.c.
 */

#ifndef __AIDP_TS_H__
#define __AIDP_TS_H__

#define APP_ETHER_DEV_NAME "eth0"


/*************************************************/
/**********     Function Prototypes     **********/
/*************************************************/
int appGetModelandMAC(unsigned short *appID, unsigned char* appMAC);
int appConfigEthInterface(const unsigned char *ip_addr,
						  const unsigned char *netmask,
						  const unsigned char *gw_addr);
int appSaveEthConfiguration(void);

// For TS, setting static IP automatically stops dhcpcd
#define appKillDynamicIPdaemons()	0


#endif //__AIDP_TS_H__
