/*
 *  Module:  aidpaux.h (Avocent Install and Discovery Protocol)
 *
 *  Author:  Marcelo Peccin <marcelo.peccin@avocent.com>
 *
 *  From the original:  Avocent Install and Discovery Protocol for DSR
 *             Author:  Jamie Collins (January 2002)
 *
 *  Copyright:  (c) 2006 Avocent Corporation
 *
 *  Date:  May 10, 2006
 *
 *  Comments:  Avocent Install and Discovery Protocol auxiliary functions interface.
 *             See also aidpaux.c and aidp.h files.
 */

#ifndef __AIDPAUX_H__
#define __AIDPAUX_H__

extern word appID;
extern byte appMAC[];
extern byte appIP[];
extern byte appSubNet[];
extern byte appGw[];


/*************************************************/
/**********     Function Prototypes     **********/
/*************************************************/
int initAppVars(void);
int process_socket_message(AIDP_SOCKET_MESSAGE *psocket_data);
int set_appliance_ip(byte *ip_addr, byte *netmask, byte *gw_addr);
int update_appliance_ip(byte *ip_addr, byte *netmask, byte *gw_addr);
int process_send(AIDP_SOCKET_MESSAGE *psocket_data, byte *sendbuf, int sendlen);
int kill_other_dynamicIP_daemons(void);


#endif //__AIDPAUX_H__
