/* vi: set sw=4 ts=4: */
/*
 * deluser (remove lusers from the system ;) for TinyLogin
 *
 * Copyright (C) 1999 by Lineo, inc. and John Beppu
 * Copyright (C) 1999,2000,2001 by John Beppu <beppu@codepoet.org>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 */

#include <sys/stat.h>
#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "busybox.h"


#include "delline.c"

#ifdef CYCLADES

//[RK]May/08/06 - event notification
extern void writeevt(int, char *, ...);

// Regina Kodato - Nov/19/03
// remove username from supplementary groups
static void delete_username_supgroup(char * username)
{
	FILE * grp;
	size_t len, len1=0, c;
	char *buffer, *a, *b;
	struct stat statb;

	if ((grp = fopen(bb_path_group_file, "r")) == 0) {
		return;
	}
	stat(bb_path_group_file,&statb);
	len = statb.st_size;
	buffer = (char *) malloc(len);
	if (!buffer) return;
	fread(buffer, len, sizeof(char), grp);
	fclose(grp);

	a = buffer;

	while (a) {
		if ((a = strstr(a,username)) == NULL) break;
		c = strlen(username);
		b = a+c;
		//[RK]Jul/02/04 Fixed 2084
		if (*(a-1) && (*(a-1) != ' ') && (*(a-1) != ',') && (*(a-1) != ':')) {
			a = b;
			continue;
		}
		if (*b && (*b != ' ') && (*b != ',') && (*b != '\n')) {
			a = b;
			continue;
		}
		if (*(a-1) == ',') {
			c++;
			a--;
		} else {
			if (*(a-2) == ',') {
				a -= 2;
				c += 2;
			}
		}
		strcpy(a,a+c);
		len1 += c;
	}
	if (len1) {
		grp = fopen(bb_path_group_file,"w");
		fwrite(buffer, len-len1, sizeof(char), grp);
		fclose(grp);
	}
}
#endif

static const char deluser_format[]="%s: User could not be removed from %s";

int deluser_main(int argc, char **argv)
{
	/* int successful; */
	int failure;

	if (argc != 2) {
		bb_show_usage();
	} else {

		failure = del_line_matching(argv[1], bb_path_passwd_file);
		if (failure) {
			bb_error_msg_and_die(deluser_format, argv[1], bb_path_passwd_file);
		}
#ifdef CONFIG_FEATURE_SHADOWPASSWDS
		failure = del_line_matching(argv[1], bb_path_shadow_file);
#ifndef CYCLADES
		if (failure) {
			bb_error_msg_and_die(deluser_format, argv[1], bb_path_shadow_file);
		}
#endif
		failure = del_line_matching(argv[1], bb_path_gshadow_file);
#ifndef CYCLADES
		if (failure) {
			bb_error_msg_and_die(deluser_format, argv[1], bb_path_gshadow_file);
		}
#endif
#endif
		failure = del_line_matching(argv[1], bb_path_group_file);
#ifndef CYCLADES
		if (failure) {
			bb_error_msg_and_die(deluser_format, argv[1], bb_path_group_file);
		}
#else
		delete_username_supgroup(argv[1]); //[RK]Nov/19/03
#endif

	}
#ifdef CYCLADES
	writeevt(17,"us",argv[1]);
#endif
	return (EXIT_SUCCESS);
}

/* $Id: deluser.c,v 1.2 2006/06/24 18:42:51 edson Exp $ */
