#!/bin/sh

VALUE=0              # working variable
H_ADC1=65535         # Analog Port 1 A/D Converter high limit 
L_ADC1=0             # Analog Port 1 A/D Converter low limit
H_ADC2=65535         # Analog Port 2 A/D Converter high limit 
L_ADC2=0             # Analog Port 2 A/D Converter low limit
D1=0                 # Digital Port 1 status (1-closed, 0-open)
D2=0                 # Digital Port 2 status (1-closed, 0-open)
D3=0                 # Digital Port 3 status (1-closed, 0-open)
D4=0                 # Digital Port 4 status (1-closed, 0-open)
D5=0                 # Digital Port 5 status (1-closed, 0-open)
D6=0                 # Digital Port 6 status (1-closed, 0-open)
D7=0                 # Digital Port 7 status (1-closed, 0-open)
D8=0                 # Digital Port 8 status (1-closed, 0-open)

ADC1=2               # Number of times Analog Port 1 warning will be sent
ADC2=2               # Number of times Analog Port 2 warning will be sent
DIG1=2               # Number of times Digital Port 1 warning will be sent
DIG2=2               # Number of times Digital Port 2 warning will be sent
DIG3=2               # Number of times Digital Port 3 warning will be sent
DIG4=2               # Number of times Digital Port 4 warning will be sent
DIG5=2               # Number of times Digital Port 5 warning will be sent
DIG6=2               # Number of times Digital Port 6 warning will be sent
DIG7=2               # Number of times Digital Port 7 warning will be sent
DIG8=2               # Number of times Digital Port 8 warning will be sent


if [ -f /etc/io_counter ]; then
  grep -v ^\# /etc/io_counter | grep counters > /tmp/.io_aux
  while read LOC ADC1 ADC2 DIG1 DIG2 DIG3 DIG4 DIG5 DIG6 DIG7 DIG8 < /tmp/.io_aux
  do
    if [ -z "$LOC" ]; then
      break
    fi
    if [ "$LOC" = "counters" ]; then
      break
    fi
  done
fi

# Check ADC1
VALUE=`/bin/pu -r -d /dev/adc1 -o`
if [ $ADC1 != 0 ] && ( [ $VALUE -gt $H_ADC1 ] || [ $VALUE -lt $L_ADC1 ] ); then
  [ $ADC1 -gt 0 ] && ADC1=`expr $ADC1 - 1`		# update counter
  #Print a Warning message.
  echo "WARNING! ANALOG Port 1 (ADC1) below/above limit. It is currently at $VALUE" > /dev/console

  #Send a Warning e-mail.
  #sendmail -t t@none.com -f a@none.com -s "TS110 ANALOG Port 1" -m "ANALOG Port 1 (ADC1) below/above limit. It is currently at $VALUE" -h 10.0.0.2
fi

# Check ADC2
VALUE=`/bin/pu -r -d /dev/adc2 -o`
if [ $ADC2 != 0 ] && ( [ $VALUE -gt $H_ADC2 ] || [ $VALUE -lt $L_ADC2 ] ); then
  [ $ADC2 -gt 0 ] && ADC2=`expr $ADC2 - 1`		# update counter
  #Print a Warning message.
  echo "WARNING! ANALOG Port 2 (ADC2) below/above limit. It is currently at $VALUE" > /dev/console

  #Send a Warning e-mail.
  #sendmail -t t@none.com -f a@none.com -s "TS110 ANALOG Port 2" -m "ANALOG Port 2 (ADC2) below/above limit. It is currently at $VALUE" -h 10.0.0.2
fi

# Check DIGITAL PORT 1
VALUE=`/bin/pu -r -d /dev/gpio -p 1`
if [ $DIG1 != 0 ] && [ $VALUE -ne $D1 ]; then
  [ $DIG1 -gt 0 ] && DIG1=`expr $DIG1 - 1`

  #Print a Warning message.
  echo "WARNING! Digital Port 1 status has changed. It is currently $VALUE" > /dev/console

  #Send a Warning e-mail.
  #sendmail -t t@none.com -f a@none.com -s "TS110 Digital Port 1" -m "Digital Port 1 status has changed. It is currently $VALUE" -h 10.0.0.2
fi

# Check DIGITAL PORT 2
VALUE=`/bin/pu -r -d /dev/gpio -p 2`
if [ $DIG2 != 0 ] && [ $VALUE -ne $D2 ]; then
  [ $DIG2 -gt 0 ] && DIG2=`expr $DIG2 - 1`

  #Print a Warning message.
  echo "WARNING! Digital Port 2 status has changed. It is currently $VALUE" > /dev/console

  #Send a Warning e-mail.
  #sendmail -t t@none.com -f a@none.com -s "TS110 Digital Port 2" -m "Digital Port 2 status has changed. It is currently $VALUE" -h 10.0.0.2
fi

# Check DIGITAL PORT 3
VALUE=`/bin/pu -r -d /dev/gpio -p 3`
if [ $DIG3 != 0 ] && [ $VALUE -ne $D3 ]; then
  [ $DIG3 -gt 0 ] && DIG3=`expr $DIG3 - 1`

  #Print a Warning message.
  echo "WARNING! Digital Port 3 status has changed. It is currently $VALUE" > /dev/console

  #Send a Warning e-mail.
  #sendmail -t t@none.com -f a@none.com -s "TS110 Digital Port 3" -m "Digital Port 3 status has changed. It is currently $VALUE" -h 10.0.0.2
fi

# Check DIGITAL PORT 4
VALUE=`/bin/pu -r -d /dev/gpio -p 4`
if [ $DIG4 != 0 ] && [ $VALUE -ne $D4 ]; then
  [ $DIG4 -gt 0 ] && DIG4=`expr $DIG4 - 1`

  #Print a Warning message.
  echo "WARNING! Digital Port 4 status has changed. It is currently $VALUE" > /dev/console

  #Send a Warning e-mail.
  #sendmail -t t@none.com -f a@none.com -s "TS110 Digital Port 4" -m "Digital Port 4 status has changed. It is currently $VALUE" -h 10.0.0.2
fi

# Check DIGITAL PORT 5
VALUE=`/bin/pu -r -d /dev/gpio -p 5`
if [ $DIG5 != 0 ] && [ $VALUE -ne $D5 ]; then
  [ $DIG5 -gt 0 ] && DIG5=`expr $DIG5 - 1`

  #Print a Warning message.
  echo "WARNING! Digital Port 5 status has changed. It is currently $VALUE" > /dev/console

  #Send a Warning e-mail.
  #sendmail -t t@none.com -f a@none.com -s "TS110 Digital Port 5" -m "Digital Port 5 status has changed. It is currently $VALUE" -h 10.0.0.2
fi

# Check DIGITAL PORT 6
VALUE=`/bin/pu -r -d /dev/gpio -p 6`
if [ $DIG6 != 0 ] && [ $VALUE -ne $D6 ]; then
  [ $DIG6 -gt 0 ] && DIG6=`expr $DIG6 - 1`

  #Print a Warning message.
  echo "WARNING! Digital Port 6 status has changed. It is currently $VALUE" > /dev/console

  #Send a Warning e-mail.
  #sendmail -t t@none.com -f a@none.com -s "TS110 Digital Port 6" -m "Digital Port 6 status has changed. It is currently $VALUE" -h 10.0.0.2
fi

# Check DIGITAL PORT 7
VALUE=`/bin/pu -r -d /dev/gpio -p 7`
if [ $DIG7 != 0 ] && [ $VALUE -ne $D7 ]; then
  [ $DIG7 -gt 0 ] && DIG7=`expr $DIG7 - 1`

  #Print a Warning message.
  echo "WARNING! Digital Port 7 status has changed. It is currently $VALUE" > /dev/console

  #Send a Warning e-mail.
  #sendmail -t t@none.com -f a@none.com -s "TS110 Digital Port 7" -m "Digital Port 7 status has changed. It is currently $VALUE" -h 10.0.0.2
fi

# Check DIGITAL PORT 8
VALUE=`/bin/pu -r -d /dev/gpio -p 8`
if [ $DIG8 != 0 ] && [ $VALUE -ne $D8 ]; then
  [ $DIG8 -gt 0 ] && DIG8=`expr $DIG8 - 1`

  #Print a Warning message.
  echo "WARNING! Digital Port 8 status has changed. It is currently $VALUE" > /dev/console

  #Send a Warning e-mail.
  #sendmail -t t@none.com -f a@none.com -s "TS110 Digital Port 8" -m "Digital Port 8 status has changed. It is currently $VALUE" -h 10.0.0.2
fi

echo "#I/O Monitoring - Working counters" > /etc/io_counter
echo "#        ADC1 ADC2 DIG1 DIG2 DIG3 DIG4 DIG5 DIG6 DIG7 DIG8" >> /etc/io_counter
echo "counters $ADC1 $ADC2 $DIG1 $DIG2 $DIG3 $DIG4 $DIG5 $DIG6 $DIG7 $DIG8" >> /etc/io_counter
