/*************************************************************************
 *** Intel Confidential                                      
 *** Copyright (C) Intel Corporation 2000                 
 *** All Rights Reserved.                                    
 *** --------------------------------------------------------------------
 ***
 *** Project Name: Flash Templates
 ***
 *** Module Name: Device 
 ***
 *** File: Device.H - J3 device specific template C header
 ***
 *** File Revision: $Revision: 1.1 $, $JustDate:  5/11/00 $, $Author: arnaldo $
 ***
 *** Purpose:
 ***
 ***    The purpose of this file is to establish J3 device specific
 ***    constants used at compile time and runtime.  These constants
 ***    include device layout parameters, command constants and 
 ***    function declaration flags. 
 ***
 *** $NoKeywords: $
 *************************************************************************/
/*
***************************************************************
* INTEL OEM SOFTWARE LICENSE AGREEMENT
* BETWEEN INTEL CORPORATION AND OEM/Licensee ("You")
*  (Rev 10/04/99)
*
* BY USING THIS SOFTWARE, YOU ("You" or "Licensee") ARE AGREEING 
* TO BE BOUND BY THE TERMS OF THIS AGREEMENT.  DO NOT USE THE 
* SOFTWARE UNTIL YOU HAVE CAREFULLY READ AND AGREED TO THE 
* FOLLOWING TERMS AND CONDITIONS.  IF YOU DO NOT AGREE TO THE 
* TERMS OF THIS AGREEMENT, PROMPTLY RETURN THE SOFTWARE AND ANY 
* ACCOMPANYING ITEMS. LICENSEE MUST BE AN ORIGINAL EQUIPMENT 
* MANUFACTURER ("OEM") SYSTEM DEVELOPER TO ACQUIRE ANY RIGHTS 
* IN THE SOFTWARE UNDER THIS LICENSE AGREEMENT.
*
* LICENSE: Intel Corporation ("Intel") grants the Licensee the 
* non-exclusive right to use the software program ("Software") 
* in source and / or object code form on the terms set forth 
* below.  Licensee will not use, copy, modify, rent, sell or 
* transfer the Software or any portion thereof, except as 
* provided in this Agreement.  
*
* USE RESTRICTION:
* THIS ROYALTY FREE LICENSE ALLOWS LICENSEE TO USE THE SOFTWARE 
* WITH INTEL FLASH PRODUCTS ONLY. USE OF THE SOFTWARE WITH ANY 
* OTHER FLASH PRODUCTS IS EXPRESSLY PROHIBITED UNLESS AND UNTIL 
* LICENSEE APPLIES FOR, AND IS GRANTED, IN INTEL'S SOLE DISCRETION.
* A SEPARATE WRITTEN SOFTWARE LICENSE AGREEMENT BETWEEN LICENSEE 
* AND INTEL IS NECESSARY BEFORE ANY SUCH USE.
*
* LICENSEE MAY:
* 1. Copy the Software for support, backup or archival purposes;
* 2. Install or distribute the Software in object code form only;
* 3. Install, use, modify, distribute, and/or make or have made 
* Derivatives based on the Software subject to the terms and 
* conditions in this Agreement;
* 4. Modify and/or use Software source code that Intel provides to
* the Licensee, provided that Licensee does not remove or modify 
* the "Compatibility" module, if any, in the Software or in any 
* Derivatives and subject to the other restrictions contained 
* herein;
* 5. Allow authorized contractors ("Subcontractors") engaged by 
* the Licensee for the sole purpose of product development work to
* have access to the Software solely for that purpose. 
* Subcontractors do NOT acquire any of the Licensee rights to the 
* Software provided in this Agreement.
*
* RESTRICTIONS:  
* LICENSEE IS NOT ALLOWED TO: 
* 1.  Copy, disclose or distribute the Software, in whole or in 
* part, except as provided for in this Agreement;
* 2.  Remove or modify the "Compatibility" module, if any, in 
* the Software or in any Derivatives;
* 3.  Decompile or reverse engineer any Software delivered in 
* object code form.
*
* LICENSEE MUST:
* Execute the "Compatibility" module if provided with the 
* Software.
*
* TRANSFER:  Except as provided above, Licensee may not 
* transfer or disclose the Software to any other party.
*
* OWNERSHIP AND COPYRIGHT OF SOFTWARE: Title to the Software 
* and all copies thereof remain with Intel.  The Software is 
* copyrighted and is protected by United States and 
* international copyright laws.  Licensee will not remove 
* the copyright notice from the Software.  Licensee agrees 
* to prevent the unauthorized copying of the Software.
*
* DERIVATIVES: "Derivatives" are any work that is based upon the 
* Software, such as a revision, modification, translation, or 
* compilation in which the Software is recast, transformed or 
* adapted; any adaptation, subset, addition, improvement or 
* combination of or including the Software; and any new material, 
* information or data derived from the Software, including new 
* material which may be protectable by copyright, patent or other
* proprietary rights.  Licensee is not required to provide Intel 
* with a copy of the source or object code for any Derivatives 
* created by Licensee. Licensee may use, market, sell, and/or 
* distribute Derivatives in object code form only at Licensee's own
* risk and expense.  Licensee may use, but may not market, sell or 
* distribute, source code for any Derivatives, subject to the Use 
* Restriction and other restrictions contained in this Agreement. 
* Title to Derivatives, other than the portion(s) of the 
* Derivatives consisting of any portion of the Software, shall 
* remain with Licensee.
*
* CONFIDENTIALITY: Licensee will maintain the confidentiality of 
* the source code for the Software with at least the same degree 
* of care that Licensee uses to protect Licensee's own confidential 
* and proprietary information, but with no less than a reasonable 
* degree under the circumstances. Disclosure of source code will 
* only be made to Licensee's employees on a need-to-know basis. 
* Subject to the licenses granted hereunder, Licensee shall 
* maintain the Software source code and all other proprietary 
* information relating to the Software in confidence and shall 
* not disclose to others any such source code or other Intel 
* proprietary information relating to the Software. Any 
* Subcontractors to whom Licensee discloses the source code for 
* the Software must sign a written confidentiality agreement 
* which contains terms regarding the Software no less restrictive 
* than those set forth in this Agreement.
*
* WARRANTY:  The Software is provided "AS IS". Intel warrants 
* that the media on which the Software is furnished will be free 
* from defects in material and workmanship for a period of one 
* year upon receipt. 
*
* THE ABOVE WARRANTIES ARE THE ONLY WARRANTIES OF ANY KIND GIVEN 
* BY INTEL UNDER THIS AGREEMENT. INTEL SPECIFICALLY DISCLAIMS ANY 
* OTHER WARRANTIES, EXPRESS OR IMPLIED, INCLUDING WARRANTIES OF 
* MERCHANTABILITY, NONINFRINGEMENT OR FITNESS FOR ANY PARTICULAR 
* PURPOSE.
*
* LIMITATION OF LIABILITY: NEITHER INTEL NOR ITS VENDORS OR AGENTS 
* SHALL BE LIABLE FOR ANY LOSS OF PROFITS, LOSS OF USE, LOSS OF 
* DATA, INTERRUPTION OF BUSINESS, NOR FOR INDIRECT, SPECIAL, 
* INCIDENTAL OR CONSEQUENTIAL DAMAGES OF ANY KIND WHETHER UNDER 
* THIS AGREEMENT OR OTHERWISE, EVEN IF ADVISED OF THE POSSIBILITY 
* OF SUCH DAMAGES.
*
* TERMINATION OF THIS LICENSE: Intel reserves the right to conduct 
* or have conducted audits to verify Licensee's compliance with 
* this Agreement.  Intel may terminate this Agreement at any 
* time if Licensee is in breach of any of its terms and conditions.
* Upon termination, Licensee will immediately destroy, and certify 
* in writing the destruction of, the Software and return all copies 
* of the Software and documentation to Intel.
*
* U.S. GOVERNMENT RESTRICTED RIGHTS: The Software and documentation
* were developed at private expense and are provided with 
* "RESTRICTED RIGHTS".  Use, duplication or disclosure by the 
* Government is subject to restrictions as set forth in 
* FAR52.227-14 and DFAR252.227-7013 et seq. or its successor.
*
* EXPORT LAWS: The distribution and export/re-export of the 
* Software shall be in compliance with the laws, regulations, 
* orders or other restrictions of the U.S. Export Administration 
* Regulations.
*
* APPLICABLE LAW: This Agreement is governed by the laws of the 
* State of Delaware and the United States, including patent and
* copyright laws.  Any claim arising out of this Agreement will be 
* brought in Delaware.  
*
* Intel reserves the right to use and/or include Licensee's name
* in public relations activities and marketing material after the 
* product is publicly announced.
*****************************************************************
*/
/* Page Break */
#ifndef __DEVICE_H  /* ensure this file only gets included once */
#define __DEVICE_H

/* 
 * J3 specific constants
 */

/* compile flags:  set 1 flag for each and every template
 * function.  These are used at compile time to identify
 * implementation location (common.c or device.c specific)
 * of each function.
*/

/* set compile flags to identify functions which ARE 
   implemented as device specific (i.e. will use these
   device.c functions for this template ).  Setting these
   constants to TRUE indicates that common template.c
   implementations of these functions will NOT be
   used. */

#define DEVICE_ERASE_ALL_BLOCKS       TRUE
#define DEVICE_ERASE_SUSPEND          TRUE
#define DEVICE_EXTENDED_QUERY         TRUE
#define DEVICE_GET_BLOCK_ADDRESS      TRUE
#define DEVICE_LOCK_BLOCK             TRUE
#define DEVICE_LOCK_PROTECTION        TRUE
#define DEVICE_PAGE_MODE              TRUE
#define DEVICE_PROGRAM_FLASH_BUFFERED FALSE
#define DEVICE_PROGRAM_PROTECTION     TRUE
#define DEVICE_PROGRAM_SUSPEND        TRUE
#define DEVICE_READ_BLOCK_STATUS      TRUE
#define DEVICE_READ_PROTECTION        TRUE
#define DEVICE_RESUME                 TRUE
#define DEVICE_UNLOCK_ALL_BLOCKS      TRUE 

/* set compile flags to identify functions which are NOT 
   implemented as device specific (i.e. will use the 
   common.c functions for these functions */

#define DEVICE_CLEAR_STATUS           FALSE
#define DEVICE_ERASE_BLOCK            FALSE
#define DEVICE_GET_QUERY_ADDRESS      FALSE
#define DEVICE_LOCK_DOWN_BLOCK        FALSE 
#define DEVICE_PROGRAM_FLASH          FALSE
#define DEVICE_QUERY                  FALSE
#define DEVICE_READ_DEVICE_ID         FALSE
#define DEVICE_READF                  FALSE
#define DEVICE_READ_FLASH             FALSE
#define DEVICE_READ_STATUS            FALSE
#define DEVICE_SEC_EXTENDED_QUERY     FALSE
#define DEVICE_UNLOCK_BLOCK           FALSE 
#define DEVICE_WAIT_UNTIL_READY       FALSE
#define DEVICE_WRITEF                 FALSE

/* TRUE means client will implement this function external to the template */
#define CLIENT_GET_FPTR               FALSE 

/* little endian */
#define BIG_ENDIAN_ARCHITECTURE       TRUE

/* set 1 and Only 1 configuration to TRUE */
#define X_8                           TRUE
#define PX_16                         FALSE
#define X_16                          FALSE
#define X_32                          FALSE
#define ILX_32                        FALSE

/* set 1 and only 1 size to TRUE */
#define J3_32_M                       FALSE
#define J3_64_M                       FALSE
#define J3_128_M                      TRUE

/* ERASE_TIMEOUT_CYCLES = # of times to check for status ready after erase
  commands are issued to the device */
#define TMPL_ERASE_TIMEOUT            2000000L  

/* PROGRAM_TIMEOUT_CYCLES = # of times to check for status ready after 
   program commands are issued to the device */
#define TMPL_PROGRAM_TIMEOUT          1000000L

#define TMPL_BLOCKSTAT_UNLOCKED       0x0
#define TMPL_BLOCKSTAT_LOCKED         0x1
#define TMPL_BLOCKSTAT_LOCKEDDOWN     0x3

#define TMPL_PROTECTION_LOCK_LOCATION 0x0

/******************** 32M ********************/
#if J3_32_M
	#define TMPL_TOTAL_NUMBLOCKS      0x20 
	#define TMPL_BLOCK_NUMBYTES       0x20000 
	#define TMPL_TOTAL_SIZE           0x400000 
	#define TMPL_BLOCK_MASK           0xFFFF
#endif /* J3_32_M */

/******************** 64M ********************/
#if J3_64_M
	#define TMPL_TOTAL_NUMBLOCKS      0x40 
	#define TMPL_BLOCK_NUMBYTES       0x20000 
	#define TMPL_TOTAL_SIZE           0x800000 
	#define TMPL_BLOCK_MASK           0xFFFF
#endif /* J3_64_M */

/******************** 128M *******************/
#if J3_128_M
	#define TMPL_TOTAL_NUMBLOCKS      0x80 
	#define TMPL_BLOCK_NUMBYTES       0x20000 
	#define TMPL_TOTAL_SIZE           0x1000000 
	#define TMPL_BLOCK_MASK           0xFFFF
#endif /* J3_128_M */


#if X_8
	#define TMPL_OTP_NUMWORDS         0x9
	#define TMPL_OTP_BASE             0x100 /* address */
	#define TMPL_OTP_PROGRAM          0xC0
	#define TMPL_OTP_READ             0x90
	#define TMPL_OTP_LOCK             0xFD
	#define TMPL_LOCKDOWN_BIT_SET     0x2F
	#define TMPL_LOCK_BIT_SET         0x01  /* 2nd cycle lock bit command */
	#define TMPL_LOCK_BIT_CLEAR       0xD0  /* 2nd cycle lock bit command */
	#define TMPL_BLOCK_SUSPEND        0xB0
	#define TMPL_BLOCK_RESUME         0xD0
#endif

#if PX_16
	#define TMPL_OTP_NUMWORDS         0x9
	#define TMPL_OTP_BASE             0x100  /* address */
	#define TMPL_OTP_PROGRAM          0xC0C0
	#define TMPL_OTP_READ             0x9090
	#define TMPL_OTP_LOCK             0xFDFD
	#define TMPL_LOCKDOWN_BIT_SET     0x2F2F
	#define TMPL_LOCK_BIT_SET         0x0101 /* 2nd cycle lock bit command */
	#define TMPL_LOCK_BIT_CLEAR       0xD0D0 /* 2nd cycle lock bit command */
	#define TMPL_BLOCK_SUSPEND        0xB0B0
	#define TMPL_BLOCK_RESUME         0xD0D0
#endif

#if X_16
	#define TMPL_OTP_NUMWORDS         0x9
	#define TMPL_OTP_BASE             0x100  /* address */
	#define TMPL_OTP_PROGRAM          0x00C0
	#define TMPL_OTP_READ             0x0090
	#define TMPL_OTP_LOCK             0xFFFD
	#define TMPL_LOCKDOWN_BIT_SET     0x002F
	#define TMPL_LOCK_BIT_SET         0x0001 /* 2nd cycle lock bit command */
	#define TMPL_LOCK_BIT_CLEAR       0x00D0 /* 2nd cycle lock bit command */
	#define TMPL_BLOCK_SUSPEND        0x00B0
	#define TMPL_BLOCK_RESUME         0x00D0
#endif

#if X_32
	#define TMPL_OTP_NUMWORDS         0x9
	#define TMPL_OTP_BASE             0x200	  /* address */
	#define TMPL_OTP_PROGRAM          0x00C000C0
	#define TMPL_OTP_READ             0x00900090
	#define TMPL_OTP_LOCK             0xFFFDFFFD
	#define TMPL_LOCKDOWN_BIT_SET     0x002D002F
	#define TMPL_LOCK_BIT_SET         0x00010001 /* 2nd cycle lock bit command */
	#define TMPL_LOCK_BIT_CLEAR       0x00D000D0 /* 2nd cycle lock bit command */
	#define TMPL_BLOCK_SUSPEND        0x00B000B0
	#define TMPL_BLOCK_RESUME         0x00D000D0
#endif

#if ILX_32
	#define TMPL_OTP_NUMWORDS         0x9
	#define TMPL_OTP_BASE             0x200      /* address */
	#define TMPL_OTP_PROGRAM          0x00C000C0
	#define TMPL_OTP_READ             0x00900090
	#define TMPL_OTP_LOCK             0xFFFDFFFD
	#define TMPL_LOCKDOWN_BIT_SET     0x002F002F
	#define TMPL_LOCK_BIT_SET         0x00010001 /* 2nd cycle lock bit command */
	#define TMPL_LOCK_BIT_CLEAR       0x00D000D0 /* 2nd cycle lock bit command */
	#define TMPL_BLOCK_SUSPEND        0x00B000B0
	#define TMPL_BLOCK_RESUME         0x00D000D0
#endif


/********************************************************************
	PRODUCT SPECIFIC DATA DEFINES
********************************************************************/
#if X_8
	#define TMPL_BUFFER_SIZE          0x20         /* bytes */ 
	#define TMPL_WRITE_TO_BUFFER      0xE8
	#define TMPL_SET_READ_CONFIG      0x03
#endif

#if X_16
	#define TMPL_BUFFER_SIZE          0x20         /* bytes */ 
	#define TMPL_WRITE_TO_BUFFER      0x00E8
	#define TMPL_SET_READ_CONFIG      0x0003
#endif

#if X_32
	#define TMPL_BUFFER_SIZE          0x20         /* bytes */ 
	#define TMPL_WRITE_TO_BUFFER      0x00E800E8
	#define TMPL_SET_READ_CONFIG      0x00030003
#endif

#if ILX_32
	#define TMPL_BUFFER_SIZE          0x20         /* bytes */ 
	#define TMPL_WRITE_TO_BUFFER      0x00E800E8
	#define TMPL_SET_READ_CONFIG      0x00030003
#endif


/* defined for all data widths. added to flash base address. contains A16..A1 */
#define TMPL_STD_READ_MODE            0x0000
#define TMPL_PAGE_READ_MODE           0x8000


/*
 * device specific typedefs
 */

/* extended query structure */
typedef struct TMPL_ExtQueryData {
	char   ExtQueryStr[4];        /* 3 bytes + null */
	UINT8  MajorVersionNum;       /* 1 byte */
	UINT8  MinorVersionNum;       /* 1 bytes */
	UINT32 OptionalFeature;       /* 4 bytes */
	UINT8  AfterSuspendFunctions; /* 1 byte */
	UINT16 BlockLockStatus;       /* 2 bytes */
	UINT8  VccOptimum;            /* 1 byte */
	UINT8  VppOptimum;            /* 1 byte */
} TMPL_extquery;


#endif  /* __DEVICE_H */
