/* -*- linux-c -*- */
/*
    This file is part of cacpd

    Copyright (C) 2005 Cyclades Corp.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
/* Author: Oliver Kurth <oliver.kurth@cyclades.com> */

#ifndef _DATABUF_H_INCLUDED
#define _DATABUF_H_INCLUDED

struct databuf{
	char *buf;
	int size;
	int start;
	int end;
};

#define databuf_isempty(dbuf) ((dbuf)->start == (dbuf)->end)
#define databuf_length(dbuf) ((dbuf)->end - (dbuf)->start)
#define databuf_size(dbuf) ((dbuf)->size)
#define databuf_remaining(dbuf) ((dbuf)->size - (dbuf)->end)
#define databuf_get(dbuf) ((dbuf)->buf + (dbuf)->start)
#define databuf_put(dbuf) ((dbuf)->buf + (dbuf)->end)

struct databuf *create_databuf();
void destroy_databuf(struct databuf *dbuf);
int databuf_add(struct databuf *dbuf, const char *data, int len);
int databuf_add_string(struct databuf *dbuf, const char *str);
int databuf_remove(struct databuf *dbuf, int len);

int databuf_flushout(struct databuf *dbuf, int fd);
int databuf_flushin(struct databuf *dbuf, int fd);

#endif /* _DATABUF_H_INCLUDED */
