/*
 * Module: pmc.h
 *
 *      This program is free software; you can redistribute it and/or
 *      modify it under the terms of the GNU General Public License
 *      as published by the Free Software Foundation; either version
 *      2 of the License, or (at your option) any later version.
 *
 * $Log: pmc.h,v $
 * Revision 1.10  2006/06/21 13:27:33  regina
 * Changed the brand
 *
 * Revision 1.9  2004/03/16 18:23:38  regina
 * New PMD
 *
 * Revision 1.10  2004/03/05 19:06:31  regina
 * Implemented access control by pmd
 *
 * Revision 1.9  2004/01/15 16:07:24  fujima
 * bug #1181 fixed
 *
 * Revision 1.8  2003/06/10 22:21:52  fujima
 * Bug #585/586 fixed
 *
 * Revision 1.7  2003/03/21 17:10:24  fujima
 * Small fix in the servernotready string
 *
 * Revision 1.6  2003/03/20 21:03:51  fujima
 * Bug #354 and 381 fixed
 *
 * Revision 1.4  2003/03/14 19:03:45  fujima
 * Bug #354 fixed
 *
 * Revision 1.3  2003/03/12 21:09:05  fujima
 * Fixed PM menu text mispelling
 *
 * Revision 1.2  2003/02/21 19:55:57  fujima
 * Changed menu layout for PM
 *
 * Revision 1.1  2003/02/21 16:30:14  fujima
 * New PMD
 *
 * Revision 1.1  2003/02/20 20:47:17  fujima
 * New PMD
 *
*/

// Strings to be sent to the user when there's any kind
// of error in startPmdConnection
#ifdef PMDCLIENT
char menuHeaderLine[] = 
"-------------------------------------------------------\r\n";
char menuHeader[] =
"    Avocent Corporation - Power Management Utility\r\n";
char endpmsession[] = "Exit from PM session\r\n";
char noaccesslistother[] = "\r\n"
"You cannot manage the outlet(s) entered.\r\n"
"\r\n";
char internalerror[] = "Internal Problem. Contact your Console Sever Administrator\r\n ";
char chooseAnOption[] = "Please choose an option: ";
char invalidOption[] = "Invalid Option\r\n";
char outletquestion[] = "Please enter the outlet(s) (or 'h' for help): ";
char outletHelp[] =
"\r\n"
"Enter the outlet or the list of outlets you want to manage.\r\n"
"The format of the outlet is <IPDU port>.<outlet number>. \r\n"
"Example: 2.3 refers to the 3rd outlet of the IPDU in the serial port 2.\r\n"
"Type 'c' to manage the outlet(s) used by this server.\r\n"
"Type 'l' to exit the PM session.\r\n"
"\r\n";

char pmcerrorbegin[] = "\r\n"
	"It was not possible to start a Power Management Session\r\n";
char pmcerrorend[] = "\r\n"
	"Please contact your Console Server Administrator.\r\n";

char nooutletlist[] = "The outlet list has a wrong syntax.";
char anothersession[] = "There is another session connected in this port.";
char noserverline[] = "Could not access the server line configuration.";
char noserversess[] = "Could not access the server session information.";
char noaccess[] = "You can't access any Power Management functionality.";
char servernotready[] =	"The server is not ready. It's probably on its start process.";
char ipdunotvalid[] = "Outlet %d.%d - the serial port #%d is not configured as IPDU.";
char outletnotvalid[] = "Outlet %d.%d - the outlet is out of range.";
char noaccesslist[] = "You don't have permission to manage the outlet(s) used by this server.";

static pmcInfo* pmc_alloc_pmcinfo(CY_SESS * sess, int ipdu, int outlet,char other);
static void pmc_free_pmcinfo(pmcInfo * pmc);
static void pmc_mount_menu(CY_SESS * sess, char other);
static void pmc_treat_option(CY_SESS * sess, int option, 
	void write_data(char *data,int cnt));
#else
char servernotready[] =	"\r\n"
			"It was impossible to start a Power Management Session\r\n"
			"The server is not ready. It's probably on its start process.\r\n"
			"Please contact your Console Server Administrator if this message persists.\r\n";
#endif
void pmc_logout(CY_SESS *sess);
void pmc_login(CY_SESS * sess, char *pmoutlet, char outlet,
				void write_line(char * line,int cnt));
void pmc_treat_input(CY_SESS * sess, void write_data(char *data,int cnt));
void pmc_treat_sigusr2(CY_SESS * sess, void write_data(char*data,int cnt));
