
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <fcntl.h>
#include <string.h>
#include <termios.h>
#include <signal.h>
#include <ctype.h>
#include <errno.h>

#include "rot_nports.h"

int get_machine_type(struct MachineType *pmt)
{
	char buffer[256], *p;
	int fd;

	pmt->nports = 0;
	strcpy(pmt->name, "UNKNOWN");

	if ((fd = open("/proc/bdinfo", O_RDONLY)) < 0) {
		return(0);
	}

	if (read(fd, buffer, sizeof(buffer)) <= 0) {
		close(fd);
		return(0);
	}

	close(fd);

	if ((p = strtok(buffer, "!")) == NULL) {
		return(0);
	}
	strcpy(pmt->board_name, p);

	if ((p = strtok(NULL, "!")) == NULL) {
		return(0);
	}
	pmt->nports = atoi(p);

	if ((p = strtok(NULL, "!")) == NULL) {
		return(0);
	}
	strcpy(pmt->name, p);

	if ((p = strtok(NULL, "!")) == NULL) {
		return(0);
	}
	pmt->board_type = atoi(p);

	if ((p = strtok(NULL, "!")) == NULL) {
		return(0);
	}
	strcpy(pmt->vendor_name, p);

	if ((p = strtok(NULL, "!")) == NULL) {
		return(0);
	}
	strcpy(pmt->prod_line, p);

	if ((p = strtok(NULL, "!")) == NULL) {
		return(0);
	}

	// Discard prod_name
	if ((p = strtok(NULL, "!")) == NULL) {
		return(0);
	}

	// Discard pcmcia
	if ((p = strtok(NULL, "!")) == NULL) {
		return(0);
	}
	strcpy(pmt->version, p);

	// Discard Clock freq
	if ((p = strtok(NULL, "!")) == NULL) {
		return(0);
	}
	// Discard Mem. Size
	if ((p = strtok(NULL, "!")) == NULL) {
		return(0);
	}
	// Discard Flash size
	if ((p = strtok(NULL, "!")) == NULL) {
		return(0);
	}
	if ((p = strtok(NULL, "!")) == NULL) {
		return(0);
	}
	strcpy(pmt->mac_address, p);

	return(1);

}

