#ifndef _CYFUNC_H_
#define _CYFUNC_H_

/* cyctest.c */
int GetMenuSelection(char *, char **, int, int, cyboard_t *);
int Initialize(void);
int DetectBoards(void);
int PortTest(void);
int TestSinglePort(cyboard_t *);
int TestSingleAsyncPort(asyncboard_t*, int);
int TestSignalsManually(asyncboard_t *);
int PortConversation(asyncboard_t *);
int serial_open(int portNumber);
void serial_close(int fd);

/* detect.c */
int DetectAsyncZbusBoards(cyboard_t *);

/* port.c */
int ResetPort(asyncboard_t *, int);

/* utils.c */
void ClearInput(void);
int GetKeyPressed(void);
int WasKeyPressed(void);
void PrintStatsHeader(void);
void PrintBoardStats(asyncboard_t *, int, int);
void PrintAsyncBoardInfo (asyncboard_t *);
int GetInteger(void);

/* yboard.c */
void YTestPortsOnce(asyncboard_t *);
int YSetRTS(asyncboard_t *, int, int);
int YSetDTR(asyncboard_t *, int, int);
int YSetRTSHigh(asyncboard_t *, int);
int YSetRTSLow(asyncboard_t *, int);
int YSetDTRHigh(asyncboard_t *, int);
int YSetDTRLow(asyncboard_t *, int);
int YGetInputSignal(asyncboard_t *, int, int);
int YGetDCD(asyncboard_t *, int);
int YGetDSR(asyncboard_t *, int);
int YGetCTS(asyncboard_t *, int);
int YGetDTR(asyncboard_t *, int);
int YGetRTS(asyncboard_t *, int);
int YDetectConnections(asyncboard_t *);
int YTestSignals(asyncboard_t *, int);
int YTestSignalsManually(asyncboard_t *, int);
void YPortConversation(asyncboard_t *, int, char *str_chat);

#endif
