#ifndef _CYSTRUCT_H_
#define _CYSTRUCT_H_

#include "cyclades.h"

#ifndef CY_TYPES
#define CY_TYPES
typedef unsigned long uclong;	/* 32 bits, unsigned */
typedef unsigned short ucshort;	/* 16 bits, unsigned */
typedef unsigned char ucchar;	/* 8 bits, unsigned */
#endif /* CY_TYPES  */

struct cyclades_port {
    int ch;			/* port number */
    int state;			/* channel state */
    int txchars;		/* number of transmitted chars in the current 
				 * cycle */
    int rxchars;		/* number of received chars in the current
				 * cycle */
    int errors;
    int txtotalchars;
    int rxtotalchars;
    int txtotalpackets;
    int rxtotalpackets;
    int selected;
    int rtserrors;
    int dtrerrors;
    int dsrerrors;
    int ctserrors;
    int dcderrors;
    struct cyclades_port *connectedTo;
    int connectedToNumber;
    int cyctfd;			/* file descriptor returned from open */
};

struct async_card {
    struct cyclades_port *ports;
    int irq;			/* irq that this board is using */
	char name[28];
    int channels;		/* number of channels on the board. */
    int first_port;		/* Index of the first port for this board */
    int first_line;		/* minor number of first channel on card */
    uclong porterrors;		/* Port with errors (bit mask) */ 
};

/*
 * Per card data structure 
 */
struct cyclades_card {
	int	nports;
	char name[28];
    int sync; /* is this card synchronous or not? (0/1) */
    union {
	struct async_card async;
	int i;
    } type;
};

/*
 * Naming of the names ;) 
 */
typedef struct cyclades_card cyboard_t;
typedef struct async_card asyncboard_t;
typedef struct cyclades_port port_t;

#endif
