/*
 * Detection routines for both ISA and PCI boards.
 */

#include <stdio.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/time.h>
#include <unistd.h>
#include <sys/mman.h>
#include <termios.h>
#include <stdlib.h>
#include <string.h>
#include "cyconst.h"
#include "cystruct.h"
#include "cyfunc.h"
#include "macro.h"

/*
 * =================================================================
 * This functions returns the number of cyclades ZBUS boards installed
 * in the system and fills the array of boards passed to it. The array
 * should be sufficiently large to hold the information about all the
 * cyclades board in the system. No checking is done on the level of
 * this function. The second argument is the index of the first 
 * uninitialized element in the array. I might change the implementaion
 * to do dynamic memory allocation for each board, but at this point
 * i don't see any real need for it.
 * =================================================================
 */
int
DetectAsyncZbusBoards (cyboard_t* boardp)
{
    asyncboard_t* newBoard;

    newBoard = &(boardp->type.async);

    newBoard->channels = boardp->nports;
	strcpy(newBoard->name, boardp->name);

    newBoard->ports = (port_t *) calloc (MAXCHANNELS, sizeof (port_t));
    newBoard->first_port = 1;
    boardp->sync = 0;
    return (1);
}

