/* This file was generated by mib2c and is intended for use as a mib module
   for the ucd-snmp snmpd agent. */


#ifdef IN_UCD_SNMP_SOURCE
/* If we're compiling this file inside the ucd-snmp source tree */


/* This should always be included first before anything else */
#include <config.h>


/* minimal include directives */
#include "mibincl.h"
#include "util_funcs.h"


#else				/* !IN_UCD_SNMP_SOURCE */


#include <ucd-snmp/ucd-snmp-config.h>
#include <ucd-snmp/ucd-snmp-includes.h>
#include <ucd-snmp/ucd-snmp-agent-includes.h>


#endif				/* !IN_UCD_SNMP_SOURCE */


#include "cyACSAdm.h"
#include "cycommon.h"

static int cy_oper = 0;

/* 
 * cyACSAdm_variables_oid:
 *   this is the top level oid that we want to register under.  This
 *   is essentially a prefix, with the suffix appearing in the
 *   variable below.
 */


oid cyACSAdm_variables_oid[] = { 1, 3, 6, 1, 4, 1, 2925, 4, 4 };


/* 
 * variable2 cyACSAdm_variables:
 *   this variable defines function callbacks and type return information 
 *   for the cyACSAdm mib section 
 */


struct variable2 cyACSAdm_variables[] = {
/*  magic number        , variable type , ro/rw , callback fn  , L, oidsuffix */
#define   CYACSSAVE             1
	{CYACSSAVE, ASN_INTEGER, RWRITE, var_cyACSAdm, 1, {1}},
#define   CYACSSERIALHUP        2
	{CYACSSERIALHUP, ASN_INTEGER, RWRITE, var_cyACSAdm, 1, {2}},

};
/*    (L = length of the oidsuffix) */


/*
 * init_cyACSAdm():
 *   Initialization routine.  This is called when the agent starts up.
 *   At a minimum, registration of your variables should take place here.
 */
void init_cyACSAdm(void)
{


	/* register ourselves with the agent to handle our mib tree */
	REGISTER_MIB("cyACSAdm", cyACSAdm_variables, variable2,
		     cyACSAdm_variables_oid);


	/* place any other initialization junk you need here */
}


/*
 * var_cyACSAdm():
 *   This function is called every time the agent gets a request for
 *   a scalar variable that might be found within your mib section
 *   registered above.  It is up to you to do the right thing and
 *   return the correct value.
 *     You should also correct the value of "var_len" if necessary.
 *
 *   Please see the documentation for more information about writing
 *   module extensions, and check out the examples in the examples
 *   and mibII directories.
 */
unsigned char *var_cyACSAdm(struct variable *vp,
			    oid * name,
			    size_t * length,
			    int exact,
			    size_t * var_len, WriteMethod ** write_method)
{


	/* variables we may use later */
	static long long_ret;
	static u_long ulong_ret;
	static unsigned char string[SPRINT_MAX_LEN];
	static oid objid[MAX_OID_LEN];
	static struct counter64 c64;


	if (header_generic(vp, name, length, exact, var_len, write_method)
	    == MATCH_FAILED)
		return NULL;


	/* 
	 * this is where we do the value assignments for the mib results.
	 */
	switch (vp->magic) {


	case CYACSSAVE:
		*write_method = write_cyACSSave;
		long_ret = 0;
		return (unsigned char *) &long_ret;

	case CYACSSERIALHUP:
		*write_method = write_cyACSSerialHUP;
		long_ret = 0;
		return (unsigned char *) &long_ret;


	default:
		ERROR_MSG("");
	}
	return NULL;
}

int
write_cyACSSave(int action,
		u_char * var_val,
		u_char var_val_type,
		size_t var_val_len,
		u_char * statP, oid * name, size_t name_len)
{
	static long *long_ret;
	int size;

	switch (action) {
	case RESERVE1:
		if (var_val_type != ASN_INTEGER) {
			fprintf(stderr,
				"write to cyACSSave not ASN_INTEGER\n");
			return SNMP_ERR_WRONGTYPE;
		}
		if (var_val_len > sizeof(long_ret)) {
			fprintf(stderr,
				"write to cyACSSave: bad length\n");
			return SNMP_ERR_WRONGLENGTH;
		}
		break;


	case RESERVE2:
		break;


	case FREE:
		/* Release any resources that have been allocated */
		break;


	case ACTION:
		/* The variable has been stored in long_ret for
		   you to use, and you have just been asked to do something with
		   it.  Note that anything done here must be reversable in the UNDO case */
		cy_oper = *(long*)var_val; //[RK]Nov/22/02 BUG#89
		break;


	case UNDO:
		/* Back out any changes made in the ACTION case */
		break;


	case COMMIT:
		/* Things are working well, so it's now safe to make the change
		   permanently.  Make sure that anything done here can't fail! */
		if (cy_oper) {
			system("saveconf >/dev/null 2>&1 &"); //[RK]Nov/22/02 BUG#89
		}
		break;
	}
	return SNMP_ERR_NOERROR;
}

int
write_cyACSSerialHUP(int action,
		     u_char * var_val,
		     u_char var_val_type,
		     size_t var_val_len,
		     u_char * statP, oid * name, size_t name_len)
{
	static long *long_ret;
	int size;

	switch (action) {
	case RESERVE1:
		if (var_val_type != ASN_INTEGER) {
			fprintf(stderr,
				"write to cyACSSerialHUP not ASN_INTEGER\n");
			return SNMP_ERR_WRONGTYPE;
		}
		if (var_val_len > sizeof(long_ret)) {
			fprintf(stderr,
				"write to cyACSSerialHUP: bad length\n");
			return SNMP_ERR_WRONGLENGTH;
		}
		break;

	case RESERVE2:
		break;


	case FREE:
		/* Release any resources that have been allocated */
		break;


	case ACTION:
		/* The variable has been stored in long_ret for
		   you to use, and you have just been asked to do something with
		   it.  Note that anything done here must be reversable in the UNDO case */
		cy_oper = *(long*)var_val; //[RK]Nov/22/02 BUG#89
		break;


	case UNDO:
		/* Back out any changes made in the ACTION case */
		break;


	case COMMIT:
		/* Things are working well, so it's now safe to make the change
		   permanently.  Make sure that anything done here can't fail! */
		if (cy_oper) {	//[RK]Nov/22/02 = BUG#89
			system("signal_ras hup >/dev/null 2>&1i &");
		}
		break;
	}
	return SNMP_ERR_NOERROR;
}
