/* This file was generated by mib2c and is intended for use as a mib module
   for the ucd-snmp snmpd agent. */


#ifdef IN_UCD_SNMP_SOURCE
/* If we're compiling this file inside the ucd-snmp source tree */


/* This should always be included first before anything else */
#include <config.h>


/* minimal include directives */
#include "mibincl.h"
#include "util_funcs.h"


#else				/* !IN_UCD_SNMP_SOURCE */


#include <ucd-snmp/ucd-snmp-config.h>
#include <ucd-snmp/ucd-snmp-includes.h>
#include <ucd-snmp/ucd-snmp-agent-includes.h>


#endif				/* !IN_UCD_SNMP_SOURCE */


#include "cyACSSys.h"
#include "cycommon.h"

static char pname[32];
static char pversion[32];
static char pdevice_id[16];
static int flash_size=0;
static int ram_size=0;
static int cpu_clock=0;

int cy_numports;

/* 
 * cyACSSys_variables_oid:
 *   this is the top level oid that we want to register under.  This
 *   is essentially a prefix, with the suffix appearing in the
 *   variable below.
 */


oid cyACSSys_variables_oid[] = { 1, 3, 6, 1, 4, 1, 2925, 4, 1 };


/* 
 * variable2 cyACSSys_variables:
 *   this variable defines function callbacks and type return information 
 *   for the cyACSSys mib section 
 */


struct variable2 cyACSSys_variables[] = {
/*  magic number        , variable type , ro/rw , callback fn  , L, oidsuffix */
#define   CYACSPNAME            1
	{CYACSPNAME, ASN_OCTET_STR, RONLY, var_cyACSSys, 1, {1}},
#define   CYACSVERSION          2
	{CYACSVERSION, ASN_OCTET_STR, RONLY, var_cyACSSys, 1, {2}},
#define   CYACSFLASH          	5
	{CYACSFLASH, ASN_INTEGER, RONLY, var_cyACSSys, 1, {5}},
#define   CYACSRAM          	6
	{CYACSRAM, ASN_INTEGER, RONLY, var_cyACSSys, 1, {6}},
#define   CYACSCPU          	7
	{CYACSCPU, ASN_INTEGER, RONLY, var_cyACSSys, 1, {7}},
#define   CYACSDEVID          	8
	{CYACSDEVID, ASN_OCTET_STR, RONLY, var_cyACSSys, 1, {8}},

};
/*    (L = length of the oidsuffix) */


/*
 * init_cyACSSys():
 *   Initialization routine.  This is called when the agent starts up.
 *   At a minimum, registration of your variables should take place here.
 */
void init_cyACSSys(void)
{
	FILE *fdo;	
	int fd, size, cnt;
	char buffer[256], *p, paux[100];

	if ((fd = open("/proc/bdinfo", O_RDONLY)) > 0) {
		read(fd, buffer, sizeof(buffer));
		close(fd);

		p = strtok(buffer, "!");
		strcpy(pname, p);
		p = strtok(NULL, "!");
		cy_numports = atoi(p);
		p = strtok(NULL, "!");	// strcpy(name, p);
		p = strtok(NULL, "!");	// board_type = atoi(p);
		p = strtok(NULL, "!");	// strcpy(vendor_name, p);
		p = strtok(NULL, "!");	// strcpy(prod_name, p);
		p = strtok(NULL, "!");
		strcpy(pversion, p);
		p = strtok(NULL, "!");
		cpu_clock = atoi(p);
		p = strtok(NULL, "!");
		ram_size = atoi(p);
		p = strtok(NULL, "!");
		flash_size = atoi(p);
		p = strtok(NULL, "!");
		strcpy(pdevice_id, p);
	}
	
	/* register ourselves with the agent to handle our mib tree */
	REGISTER_MIB("cyACSSys", cyACSSys_variables, variable2,
		     cyACSSys_variables_oid);


	/* place any other initialization junk you need here */
}


/*
 * var_cyACSSys():
 *   This function is called every time the agent gets a request for
 *   a scalar variable that might be found within your mib section
 *   registered above.  It is up to you to do the right thing and
 *   return the correct value.
 *     You should also correct the value of "var_len" if necessary.
 *
 *   Please see the documentation for more information about writing
 *   module extensions, and check out the examples in the examples
 *   and mibII directories.
 */
unsigned char *var_cyACSSys(struct variable *vp,
			    oid * name,
			    size_t * length,
			    int exact,
			    size_t * var_len, WriteMethod ** write_method)
{
	static long long_ret;
	
	if (header_generic(vp, name, length, exact, var_len, write_method)
	    == MATCH_FAILED)
		return NULL;

	/* 
	 * this is where we do the value assignments for the mib results.
	 */
	switch (vp->magic) {

	case CYACSPNAME:
		*var_len = strlen(pname);
		return (unsigned char *) pname;

	case CYACSVERSION:
		*var_len = strlen(pversion);
		return (unsigned char *) pversion;
		
	case CYACSFLASH:
		*var_len = sizeof(long);
		long_ret = flash_size;
		return (unsigned char *) &long_ret;
		break;

	case CYACSRAM:
		*var_len = sizeof(long);
		long_ret = ram_size;
		return (unsigned char *) &long_ret;
		break;

	case CYACSCPU:
		*var_len = sizeof(long);
		long_ret = cpu_clock;
		return (unsigned char *) &long_ret;
		break;

	case CYACSDEVID:
		*var_len = strlen(pdevice_id);
		return (unsigned char *) pdevice_id;

	default:
		ERROR_MSG("");
	}
	return NULL;
}
